<template>
  <basic-container>
    <avue-crud :option="option" :table-loading="loading" :data="data" :page.sync="page" :permission="permissionList"
      :before-open="beforeOpen" v-model="form" ref="crud" @row-update="rowUpdate" @row-save="rowSave" @row-del="rowDel"
      @search-change="searchChange" @search-reset="searchReset" @selection-change="selectionChange" @current-change="currentChange"
      @size-change="sizeChange" @refresh-change="refreshChange" @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger" size="small" icon="el-icon-delete" plain v-if="permission.bussiness_delete" @click="handleDelete">删 除
        </el-button>
       <el-button type="success" size="small" icon="el-icon-upload" plain v-if="permission.bussiness_generateapi" @click="generateDoc">
          生成api文档
        </el-button>
      </template>
      <template slot="maxLimitForm" slot-scope="scope">
        <avue-input-number v-model="scope.row.maxLimit" precision="2" controls-position></avue-input-number>
      </template>
      <template slot="apiFilePath" slot-scope="scope">
        <el-tab v-if="scope.row.apiFilePath == null">无</el-tab>
        <el-tab v-if="scope.row.apiFilePath != null&&scope.row.apiFilePath != ''">有</el-tab>
      </template>
      <template slot="enable" slot-scope="scope">
        <el-tag type="primary" v-if="scope.row.enable == 0">启用</el-tag>
        <el-tag type="danger" v-if="scope.row.enable == 1">禁用</el-tag>
      </template>
      <template slot="menu" slot-scope="{row}">
        <el-button
                type ="text"
                size="mini"
                plain
                v-if="row.enable == 1 && permission.bussiness_enable"
                @click="handleEnable(row.id, 0)">启用
        </el-button>
        <el-button
                type ="text"
                size="mini"
                plain
                v-if="row.enable == 0 && permission.bussiness_enable"
                @click="handleEnable(row.id, 1)">禁用
        </el-button>
      </template>
      <template slot="registerStatus" slot-scope="{row}">
        <el-tag plain type="warning" size="small" v-if="row.registerStatus == 100">资料完善中</el-tag>
        <el-tag plain type="primary" size="small" v-if="row.registerStatus == 98">送审中</el-tag>
        <el-tag plain type="warning" size="small" v-if="row.registerStatus == 101">协议待签署</el-tag>
        <el-tag plain type="warning" size="small" v-if="row.registerStatus == 102">审核中</el-tag>
        <el-tag plain type="success" size="small" v-if="row.registerStatus == 200">审核成功</el-tag>
        <el-tag plain type="danger" size="small" v-if="row.registerStatus == 400">审核失败</el-tag>
        <el-tag plain type="danger" size="small" v-if="row.registerStatus == 99">送审失败</el-tag>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {
    getList,
    getDetail,
    add,
    update,
    remove,
    generateApi,
    enableBussiness
  } from "@/api/guosen/bussiness";
  import {
    mapGetters
  } from "vuex";
  import md5 from 'js-md5'
  import bussinessratestrategy from "../bussiness/bussinessratestrategy.vue";

  export default {
    components:{
      bussinessratestrategy
    },
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        bussinessId: null,
        selectionList: [],
        option: {
          height: 'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          delBtn: false,
          dialogClickModal: false,
          dialogWidth: "30%",
          column: [
           {
              label: "采购商名称",
              labelWidth: 130,
              prop: "name",
              span: 24,
              rules: [{
                required: true,
                message: "请输入采购商名称",
                trigger: "blur"
              }]
            },
            {
              label: "每日提现上限",
              labelWidth: 130,
              span: 24,
              prop: "maxLimit",
              formslot: true,
              rules: [{
                required: true,
                message: "请输入每日提现上限",
                trigger: "blur"
              }]
            },
            {
              label: "服务费率（千分比）",
              prop: "serviceRate",
              labelWidth: 130,
              width: 300,
              span: 24,
              rules: [{
                required: true,
                message: "请输入关联账号的名称",
                trigger: "blur"
              }]
            },
            {
              label: "账号",
              prop: "userName",
              labelWidth: 130,
              display: true,
              span: 24,
              rules: [{
                required: true,
                message: "请输入关联账号的名称",
                trigger: "blur"
              }]
            },
            {
              label: "密码",
              prop: "userPassword",
              labelWidth: 130,
              span: 24,
              display: true,
              hide: true,
              rules: [{
                required: true,
                message: "请输入关联账号的密码",
                trigger: "blur"
              }]
            },
            {
              label: "最低采购金额",
              prop: "leastPrice",
              labelWidth: 130,
              span: 24,
              hide: true,
              rules: [{
                required: true,
                message: "请输入最低采购金额",
                trigger: "blur"
              }]
            },
            {
              label: "api文档",
              prop: "apiFilePath",
              slot: true,
              display: false,
              hide: true
            },

            {
              label: "回调地址",
              prop: "recallUrl",
              labelWidth: 130,
              span: 24,
              hide: true,
              addDisplay: false,
              editDisplay: false,
              rules: [{
                required: false,
                message: "请输入回调地址,比如：http://xxx.xxx.xxx.xxx/xxx",
                trigger: "blur"
              }]
            },
            {
              label: "余额(元)",
              prop: "remain",
              display: false,
              rules: [{
                required: true,
                message: "请输入关联账号的id",
                trigger: "blur"
              }]
            },
            {
              label: "启用状态",
              prop: "enable",
              type: "select",
              slot: true,
              display: false,
              dicData: [
                {
                  label: "禁用",
                  value: 1
                },
                {
                  label: "启用",
                  value: 0
                },
              ],
            },
            {
              label: "进件状态",
              prop: "registerStatus",
              type: "select",
              display: false,
              slot: true,
              dicUrl: "/api/blade-system/dict-biz/dictionary?code=merchant_register_status",
              props:{
                label: "dictValue",
                value: "dictKey"
              },
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.bussiness_add, false),
          viewBtn: this.vaildData(this.permission.bussiness_view, false),
          delBtn: this.vaildData(this.permission.bussiness_delete, false),
          editBtn: this.vaildData(this.permission.bussiness_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      handleEnable(bussinessId, enable){
        if(enable == 1){
          this.$confirm("确定要禁用吗?", {
            confirmButtonText: "确定",
            cancelButtonText: "取消",
            type: "warning"
          }).then(() => {
            let params = {"bussinessId": bussinessId, "enable": enable}
            enableBussiness(params).then(() => {
              this.onLoad(this.page);
              this.$message({
                type: "success",
                message: "操作成功!"
              });
            })
          })
        }else{
          let params = {"bussinessId": bussinessId, "enable": enable}
          enableBussiness(params).then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          })
        }
      },
      rowSave(row, done, loading) {
        row.userPassword = md5(row.userPassword)
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        if(row.userPassword){
          row.userPassword = md5(row.userPassword)
        }
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
            confirmButtonText: "确定",
            cancelButtonText: "取消",
            type: "warning"
          })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      generateDoc(){
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定重新生成api文档吗?", {
            confirmButtonText: "确定",
            cancelButtonText: "取消",
            type: "warning"
          })
          .then(() => {
            return generateApi(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
            confirmButtonText: "确定",
            cancelButtonText: "取消",
            type: "warning"
          })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          let userPasswordProp = this.findObject(this.option.column, "userPassword");
          if(type == 'edit'){
            userPasswordProp.rules[0].required = false;
          }else{
            userPasswordProp.rules[0].required = true;
          }
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage) {
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize) {
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
